{ ====== SWAG to TEXT converter =====}
{ (w) 1997-1998 by Valery Votintsev  }
{     E-mail: vot@infolink.tver.su   }
{     FIDO: 2:5021/2.30              }
{ and                                }
{     Bulat Sirazetdinov 2:5049/55   }
{ Special thanx to                   }
{     Roman Khroupnin    2:5015/97   }
{------------------------------------}
{ This programm converts             }
{ *.SWG files from SWAG database     }
{ to plain text (.TXT) files         }
{ Usage:                             }
{       swg2txt filename.swg         }
{------------------------------------}

Program SWG2TXT;

Uses DOS,LZH;

TYPE
  SwagHeader =
    RECORD
      HeadSize : BYTE;                 {size of header}
      HeadChk  : BYTE;                 {checksum for header}
      HeadID   : ARRAY [1..5] OF CHAR; {compression type tag}
      NewSize  : LONGINT;              {compressed size}
      OrigSize : LONGINT;              {original size}
      Time     : WORD;                 {packed time}
      Date     : WORD;                 {packed date}
      Attr     : WORD;                 {file attributes and flags}
      BufCRC   : LONGINT;              {32-CRC of the Buffer }
      Swag     : STRING[12];           {stored SWAG filename}
      Subject  : STRING[40];           {snipet subject}
      Contrib  : STRING[35];           {contributor}
      Keys     : STRING[70];           {search keys, comma deliminated}
      FName    : PathStr;              {filename (variable length)}
      CRC      : WORD;                 {16-bit CRC (immediately follows FName)}
    END;

    SWAGFooter =
    RECORD
       CopyRight : String[60];         { GDSOFT copyright }
       Title     : String[65];         { SWG File Title   }
       Count     : INTEGER;
    END;

Var
   HeaderBuf: SwagHeader;              { Temporary buffer     }
   NextPos:LongInt;                    { Next snipet position }
   fSize:  LongInt;                    { File size            }
   F:      File;
   Name:   NameStr;

const
 MAX=65534;

type
 parr1=^tarr1;
 tarr1=array[0..MAX]of byte;

var
 f1:Text;
 be,en,lft:word;
 StartInd,i:Word;
 PackBuf:parr1;
 UnPackBuf:parr1;

{$F+}
Procedure GetBlock(Var Target; NoBytes : Word; Var Actual_Bytes : Word);
begin
 if NoBytes > lft then
   Actual_Bytes:=lft
 else
   Actual_Bytes:=NoBytes;

 move(PackBuf^[be],Target,Actual_Bytes);
 be:=be+Actual_Bytes;
 lft:=lft-Actual_Bytes;
end;

Procedure PutBlock(Var Source; NoBytes : Word; Var Actual_Bytes : Word);
begin
  move(Source,UnPackBuf^[StartInd],NoBytes);
  Inc(StartInd,NoBytes);
  en:=en+NoBytes;
  Actual_Bytes:=NoBytes;
end;

begin

  If ParamStr(1)<>'' then  begin

    Name:=ParamStr(1);
    i:=Pos('.',Name);
    If i>0 then Name[0]:=Chr(i-1);

    getmem(PackBuf,  sizeof(tarr1));
    getmem(UnPackBuf,sizeof(tarr1));

    Assign(F,ParamStr(1));
    Reset(F,1);

    FSize:=FileSize(F);
    NextPos:=0;

    While (nextPos+SizeOf(HeaderBuf)) < FSize do begin
      Seek(F,NextPos);
      BlockRead(F,HeaderBuf,SizeOf(HeaderBuf));

      seek(f,NextPos+HeaderBuf.HeadSize+2);
      blockread(f,PackBuf^,HeaderBuf.NewSize);

{$I-}
      mkdir(Name+'.SRC');
      if ioresult<>0 then;
{$I+}
      assign(f1,Name+'.SRC\'+HeaderBuf.FName);
      rewrite(f1);

      Writeln(F1,' From: ',HeaderBuf.Contrib);
      Writeln(F1,' Subj: ',HeaderBuf.Subject);
      Writeln(F1,' Keys: ',HeaderBuf.Keys   );
      Writeln(F1,'----------------------------------');

      be:=0;
      en:=0;
      lft:=HeaderBuf.NewSize;
      StartInd:=0;


      LZHUnPack(HeaderBuf.OrigSize,GetBlock,PutBlock);

      For i:=0 to HeaderBuf.OrigSize-1 do begin
        If UnPackBuf^[i] = 26 then Break;
        write(f1,Char(UnPackBuf^[i]));
      end;

      close(f1);

      NextPos:=NextPos+HeaderBuf.HeadSize+HeaderBuf.NewSize+2;
    end;

    Close(F);

 end;
end.
